// // // // // // // // // // // // // // // //
//
//	ClientApplication.cc
//
//	erstellt 4.12.97 von Andreas Warnke
//	geändert 2.1.98 von Andreas Warnke
//



// // // // // // // // // // // // // // // //
//
//	include
//

#include "ClientApplication.h"
#include "ConnectionStatus.h"
#include "Ebene.h"
#include "ObjectBitmap.h"
#include "Definitions.h"



// // // // // // // // // // // // // // // //
//
//	Konstruktor:
//

ClientApplication :: ClientApplication()
	: BApplication(
		ClientApplication_MIME_ )
{
	//	Status-Fenster:
	Login = NULL;
	PostMessage ( Msg_Login );
};



// // // // // // // // // // // // // // // //
//
//	Destruktor:
//

ClientApplication :: ~ClientApplication () 
{
	//	Löschen der Object-Bitmaps:
	ObjectBitmap :: DeleteMaps ();
};



// // // // // // // // // // // // // // // //
//
//	DispatchMessage:
//

void ClientApplication :: DispatchMessage ( 
	BMessage * inMessage,
	BHandler * inHandler)
{
	switch ( inMessage -> what )
	{
	case CA_InterApplicationMessage:
		//	Dies ist eine Info vom Server.
		//	(Die hier nicht landen sollte)		
		//	Fehlerdialog:
		BAlert * ServerError = new BAlert (
			"Error",
			"Message send to wrong Looper.",
			"Hmm..." );
		if ( ServerError != NULL )
			ServerError -> Go ( NULL );
		break;
		
	case B_ABOUT_REQUESTED:
		Info ();
		break;
	
	default:
		//	vielleicht weiß das BWIndow was mit anzufangen.:
		inherited :: DispatchMessage ( inMessage, inHandler );
	};
};




// // // // // // // // // // // // // // // //
//
//	MessageReceived:
//

void ClientApplication :: MessageReceived ( 
	BMessage * inMessage)
{
	switch ( inMessage -> what )
	{
	case Msg_Login:
		if ( Login == NULL )
			Login = new ConnectionStatus ( BRect ( 80, 80, 479, 209 ));
		else
		{
			Login -> Show ();
			Login -> Activate ();
		};
		break;
	
	default:
		//	vielleicht weiß das BWIndow was mit anzufangen.:
		inherited :: MessageReceived ( inMessage );
	};
};




// // // // // // // // // // // // // // // //
//
//	Info:
//

void ClientApplication :: Info ()
{
	//	Info:
	BAlert * sInfo = new BAlert (
		"Info",
		"Enemy Territory\n"
		"\n"
		"Client version: 1.0.3\n"
		"Protocol version: 1\n"
		"\n"
		"written by Andreas Warnke\n"
		"awarnke@cip.informatik.uni-wuerzburg.de\n",
		"Yeah!" );
	if ( sInfo != NULL )
		sInfo -> Go ( NULL );
};



// // // // // // // // // // // // // // // //
//
//	GetScreenRect:
//

BRect ClientApplication :: GetScreenRect ()
{
	//	return:
	return BScreen (B_MAIN_SCREEN_ID) . Frame();
};



//
//	Ende.
//
// // // // // // // // // // // // // // // //